'use strict';

var _ = require( 'lodash' );
var escapeRegex = require( 'escape-string-regexp' );

module.exports = function( pattern ) {

    var tokens = pattern.split( '/' );
    var escapedTokens = _.map( tokens, function( token ) {

        switch( token ) {

            case '#':
                return '([\\w\\.\\-\\$]+(\/[\\w\\.\\-\\$]+)*)';

            case '+':
                return '([\\w\\.\\-\\$]+)';

            default:
                return escapeRegex( token );
        }
    } );

    var expression = '^' + escapedTokens.join( '/' ) + '$';
    var regex = new RegExp( expression );
    return regex;
};
